Index: code/branches/bugger/src/network/NetworkPrereqs.h
===================================================================
--- code/branches/bugger/src/network/NetworkPrereqs.h	(revision 2532)
+++ code/branches/bugger/src/network/NetworkPrereqs.h	(revision 2533)
@@ -61,4 +61,13 @@
 #include "util/Integers.h"
 
+//-----------------------------------------------------------------------
+// Library global contants
+//-----------------------------------------------------------------------
+namespace orxonox
+{
+  static const unsigned int GAMESTATEID_INITIAL = (unsigned int)-1;
+  static const unsigned int CLIENTID_UNKNOWN    = (unsigned int)-2;
+  static const uint32_t     OBJECTID_UNKNOWN    = (uint32_t)(-1);
+}
 
 //-----------------------------------------------------------------------
@@ -67,15 +76,4 @@
 namespace orxonox
 {
-
-// Constants definition
-
-  static const unsigned int GAMESTATEID_INITIAL = (unsigned int)-1;
-  static const unsigned int CLIENTID_UNKNOWN = (unsigned int)-2;
-  static const uint32_t OBJECTID_UNKNOWN = static_cast<uint32_t>(-1);
-  static const unsigned int SCHED_PRIORITY_OFFSET = -5;
-
-  
-
-  
   class Client;
   class ClientConnection;
@@ -103,5 +101,7 @@
   class obj;
   class objInfo;
-  namespace packet{
+
+  namespace packet
+  {
     class Gamestate;
     class Packet;
Index: code/branches/bugger/src/network/Server.cc
===================================================================
--- code/branches/bugger/src/network/Server.cc	(revision 2532)
+++ code/branches/bugger/src/network/Server.cc	(revision 2533)
@@ -63,6 +63,4 @@
 {
   const unsigned int MAX_FAILURES = 20;
-  const unsigned int NETWORK_FREQUENCY = 25;
-  const float NETWORK_PERIOD = (float)1/NETWORK_FREQUENCY;
 
   /**
Index: code/branches/bugger/src/network/Server.h
===================================================================
--- code/branches/bugger/src/network/Server.h	(revision 2532)
+++ code/branches/bugger/src/network/Server.h	(revision 2533)
@@ -52,4 +52,6 @@
 {
   const int CLIENTID_SERVER = 0;
+  const unsigned int NETWORK_FREQUENCY = 25;
+  const float NETWORK_PERIOD = 1./NETWORK_FREQUENCY;
 
   /**
Index: code/branches/bugger/src/network/TrafficControl.cc
===================================================================
--- code/branches/bugger/src/network/TrafficControl.cc	(revision 2532)
+++ code/branches/bugger/src/network/TrafficControl.cc	(revision 2533)
@@ -36,4 +36,6 @@
 
 namespace orxonox {
+  
+  static const unsigned int SCHED_PRIORITY_OFFSET = -1;
 
   objInfo::objInfo(uint32_t ID, uint32_t creatorID, int32_t curGsID, int32_t diffGsID, uint32_t size, unsigned int prioperm, unsigned int priosched)
@@ -68,9 +70,8 @@
 	TrafficControl::TrafficControl()
 	{
-    RegisterRootObject(TrafficControl);
+    RegisterObject(TrafficControl);
 	  assert(instance_==0);
 	  instance_=this;
-//     targetSize = 2500;//5000bytes
-    SetConfigValue ( targetSize, 28000./25. );
+    this->setConfigValues();
 	}
 	
@@ -79,8 +80,6 @@
 	*/
 	TrafficControl::~TrafficControl()
-	{ 
-	  //was macht das genau? da instance ja gleich this ist im moment
+	{
 	  instance_=0;
-	  //muss ich alles deallozieren was ich im constructor aufgebaut habe?
 	}
 
@@ -89,20 +88,14 @@
 */
 
+  void TrafficControl::setConfigValues()
+  {
+    SetConfigValue ( bActive_, true );
+    SetConfigValue ( targetSize, 5000 );
+  }
+  
   /**
-          *eigener sortieralgorithmus
+  * sort-algorithm for sorting the objectlist after priorities
   */
-//   bool TrafficControl::priodiffer(obj i, obj j)
-//   {
-//     std::map<unsigned int, objInfo>::iterator iti;
-//     std::map<unsigned int, objInfo>::iterator itj;
-//     iti=listToProcess_.find(i.objID);
-//     itj=listToProcess_.find(j.objID);
-//     return iti->second.objValuePerm < itj->second.objValuePerm;
-//   }
-  
-  /**
-  * eigener sortieralgorithmus
-  */
-  bool TrafficControl::priodiffer(uint32_t clientID, obj i, obj j)
+  bool TrafficControl::prioritySort(uint32_t clientID, obj i, obj j)
   {
     assert(clientListPerm_.find(clientID) != clientListPerm_.end());  //make sure the client exists in our list
@@ -112,10 +105,18 @@
     int prio1 = clientListPerm_[clientID][i.objID].objValuePerm + clientListPerm_[clientID][i.objID].objValueSched;
     int prio2 = clientListPerm_[clientID][j.objID].objValuePerm + clientListPerm_[clientID][j.objID].objValueSched;
-//     int prio1 = clientListPerm_[clientID][i.objID].objID;
-//     int prio2 = clientListPerm_[clientID][j.objID].objID;
-    // NOTE: smaller priority is better
     return prio1 < prio2;
   }
 
+  /**
+  * sort-algorithm for sorting the objectList after position in original data stream
+  */
+  bool TrafficControl::dataSort(obj i, obj j)
+  {
+    int pos1 = i.objDataOffset;
+    int pos2 = j.objDataOffset;
+    return pos1 < pos2;
+  }
+
+  
 
 	void TrafficControl::processObjectList(unsigned int clientID, unsigned int gamestateID, std::list<obj> *list)
@@ -125,7 +126,4 @@
 	  currentGamestateID=gamestateID;
 	  evaluateList(clientID, list);
-	  //list hatte vorher ja vielmehr elemente, nach zuweisung nicht mehr... speicherplatz??
-// 	  *list=copiedVector;
-    //später wird copiedVector ja überschrieben, ist das ein problem für list-dh. für gamestatemanager?
 	  return;
 	}
@@ -169,42 +167,5 @@
 *Definition of private members
 */
-	
-	
-	/**
-	*copyList gets list of Gamestate Manager and turns it to *listToProcess
-	*/
-// 	void TrafficControl::copyList(std::list<obj> *list)
-// 	{
-// 	  std::list<obj>::iterator itvec;
-// 	  for(itvec = (*list).begin(); itvec != (*list).end(); itvec++)
-// 	  {
-// 	    objInfo objectA;
-// 	    objectA.objCreatorID=(*itvec).objCreatorID;
-// 	    objectA.objSize = (*itvec).objSize;
-// 	    listToProcess_.insert(std::pair<currentClientID, map<(*itvec).objID,objectA>>);//unsicher: ob map<...> so richtig ist
-// 	  }
-// 	}
-	/**
-	*updateReferenceList compares the sent list by GSmanager with the current *reference list and updates it.
-	*returns void
-	*/
-// 	void TrafficControl::updateReferenceList(std::map<unsigned int, objInfo> *list)
-// 	{
-// 	  std::map<unsigned int, Synchronisable*>::iterator itref;
-// 	  std::map<unsigned int, objInfo>::iterator itproc;
-// 	  for(itproc=listToProcess_.begin(); itproc != listToProcess_.end(); itproc++)
-// 	  {
-// 	    //itproc->first=objectid that is looked for
-// 	    if(referenceList_->find(itproc->first))
-// 	    {
-// 	      continue;
-// 	    }
-// 	    else
-// 	    {
-// 	      (*referenceList_).insert(pair<unsigned int,          Synchronisable*>((*itproc).first,Synchronisable::getSynchronisable((*itproc).first)));//important: how to get adress of an object!
-// 	      insertinClientListPerm(currentClientID,itproc->first,itproc->second);
-// 	    }
-// 	  }
-// 	}
+
 	/**
 	*updateClientListPerm
@@ -229,13 +190,4 @@
   {
     clientListTemp_[currentClientID][currentGamestateID] = std::list<obj>(*list);
-//     std::list<obj>::iterator itvec;
-//     std::map<unsigned int,std::map<unsigned int, obj> >::iterator ittemp;
-//     std::map<unsigned int, obj>::iterator ittempgs;
-//     ittemp = clientListTemp_.find(currentClientID);
-//     ittempgs = (*ittemp).find(currentGamestateID);
-//     for(itvec = list.begin(); itvec!=list.end(), itvec++)
-//     {
-//       ittempgs.insert(itvec);static
-//     }
   }
 
@@ -252,8 +204,6 @@
     {
       assert( (*itvec).objSize < 1000);
-//       COUT(0) << "==targetsize==  " << targetsize << endl;
       if ( ( size + (*itvec).objSize ) < targetsize )
       {
-//         COUT(0) << "no cut" << endl;
         size += (*itvec).objSize;//objSize is given in bytes
         ++itvec;
@@ -261,9 +211,6 @@
       else
       {
-//         COUT(0) << "cut" << endl;
         clientListPerm_[currentClientID][(*itvec).objID].objValueSched += SCHED_PRIORITY_OFFSET; // NOTE: SCHED_PRIORITY_OFFSET is negative
-//         ittemp = itvec;
         list->erase(itvec++);
-//         itvec = ittemp;
       }
 //       printList(list, currentClientID);
@@ -278,5 +225,4 @@
 	void TrafficControl::evaluateList(unsigned int clientID, std::list<obj> *list)
 	{
-	  //copyList(list);
 	
 	  //now the sorting
@@ -284,11 +230,7 @@
 	  //compare listToProcess vs clientListPerm
     //if listToProcess contains new Objects, add them to clientListPerm
-// 	  std::map<unsigned int, objInfo>::iterator itproc;
     std::list<obj>::iterator itvec;
-// 	  std::map<unsigned int, std::map<unsigned int, objInfo> >::iterator itperm;
-// 	  std::map<unsigned int, objInfo>::iterator itpermobj;
 	  for( itvec=list->begin(); itvec != list->end(); itvec++)
 	  {
-// 	    itperm = clientListPerm_.find(clientID);
 	    if ( clientListPerm_[clientID].find( (*itvec).objID) != clientListPerm_[clientID].end() )
       {
@@ -296,8 +238,4 @@
         //obj bleibt in liste und permanente prio wird berechnet
         clientListPerm_[clientID][(*itvec).objID].objDiffGS = currentGamestateID - clientListPerm_[clientID][(*itvec).objID].objCurGS;
-//         ((*itpermobj).second).objDiffGS = ((*itpermobj).second).objCurGS - currentGamestateID;
-//         permprio = clientListPerm_[clientID][(*itproc).first].objValuePerm;
-//         itpermprio = (permObjPrio_).find((*itproc).first);
-//         ((*itpermobj).second).objValuePerm = ((*itpermobj).second).objDiffGS * (*itpermprio).second;
         continue;//check next objId
       }
@@ -306,64 +244,29 @@
         // insert the object into clientListPerm
         insertinClientListPerm(clientID,*itvec);
-//         itpermobj=(*itperm).find((*itproc).first)
-//         ((*itpermobj).second).objDiffGS = ((*itpermobj).second).objCurGS - currentGamestateID;
-//         itpermprio = (permObjPrio_).find((*itproc).first);
-//         ((*itpermobj).second).objValuePerm = ((*itpermobj).second).objDiffGS * (*itpermprio).second;
         continue;//check next objId
       }
     }
 	  //end compare listToProcess vs clientListPerm
-	
-    //listToProc vs clientListTemp
-    //TODO: uncomment it again and change some things
-    /*
-    std::map<unsigned int, std::map<unsigned int, unsigned int> >::iterator ittemp;
-    std::map<unsigned int, unsigned int>::iterator ittempgs;
-    for( itproc=listToProcess_.begin(); itproc != listToProcess_.end();itproc++)
+    
+    if( bActive_ )
     {
-      ittemp = clientListTemp_->find(currentClientID);
-      if( ittempgs = (*ittemp).find(currentGamestateID))
-      {
-        if((*itproc).first == (*ittempgs).find((*itproc).first))//ja, dann ist objekt schon in der zu sendenden liste-muss nicht nochmal gesendet werden
-        {
-          (listToProcess_).erase (itproc);
-        }
-        else
-          continue;
-      }
-      else
-        continue;
-    }*/
-    //end listToProc vs clientListTemp
-    
-    //TODO: check whether we need this, cause i don't think so.
-    //listToProcess contains obj to send now, and since we give gsmanager the copiedlist and not listToProcess shorten copiedlist therefor too.
-    /*std::list<obj>::iterator itvec;
-    for(itvec = copiedVector.begin(); itvec != copiedVector.end(); itvec++)
-    {
-      if ( listToProcess_.find(itvec->objID) )
-      {
-        continue;//therefore object wasnt thrown out yet and has to be sent back to gsmanager
-      }
-      else
-      {
-        copiedVector.remove(itvec);
-      }
-    }*/
-    //sort copied list aufgrund der objprioperm in clientlistperm
-    // use boost bind here because we need to pass a memberfunction to stl sort
-    list->sort(boost::bind(&TrafficControl::priodiffer, this, clientID, _1, _2) );
-    
-    //now we check, that the creator of an object always exists on a client
-//     printList(list, clientID);
-    std::list<obj>::iterator itcreator;
-    for(itvec = list->begin(); itvec != list->end(); itvec++)
-    { 
-      fixCreatorDependencies(itvec, list, clientID);
+      //sort copied list according to priorities
+      // use boost bind here because we need to pass a memberfunction to stl sort
+      list->sort(boost::bind(&TrafficControl::prioritySort, this, clientID, _1, _2) );
+      
+      //now we check, that the creator of an object always exists on a client
+      std::list<obj>::iterator itcreator;
+      for(itvec = list->begin(); itvec != list->end(); itvec++)
+      { 
+        fixCreatorDependencies(itvec, list, clientID);
+      }
+      //end of sorting
+      //now the cutting, work the same obj out in processobjectlist and copiedlist, compression rate muss noch festgelegt werden. 
+//       printList(list, clientID);
+      cut(list, targetSize);
+      
+      //now sort again after objDataOffset
+      list->sort(boost::bind(&TrafficControl::dataSort, this, _1, _2) );
     }
-    //end of sorting
-    //now the cutting, work the same obj out in processobjectlist and copiedlist, compression rate muss noch festgelegt werden. 
-    cut(list, targetSize);
-//     printList(list, clientID);
     //diese Funktion updateClientList muss noch gemacht werden
     updateClientListTemp(list);
@@ -398,14 +301,12 @@
     }
   }
-
-
-/*
-void bvlabla(list *a){
-//sort a
-list *cache;
-cache = new list<unsigned int>(*a);
-return a;
-}
-*/
+  
+  void TrafficControl::clientDisconnected(unsigned int clientID)
+  {
+    assert(clientListTemp_.find(clientID) != clientListTemp_.end() );
+    assert(clientListPerm_.find(clientID) != clientListPerm_.end() );
+    clientListTemp_.erase(clientListTemp_.find(clientID));
+    clientListPerm_.erase(clientListPerm_.find(clientID));
+  }
 
 
Index: code/branches/bugger/src/network/TrafficControl.h
===================================================================
--- code/branches/bugger/src/network/TrafficControl.h	(revision 2532)
+++ code/branches/bugger/src/network/TrafficControl.h	(revision 2533)
@@ -38,4 +38,5 @@
 #include "util/Integers.h"
 #include "core/OrxonoxClass.h"
+#include "network/ClientConnectionListener.h"
 
 namespace orxonox {
@@ -79,5 +80,5 @@
 *
 */
-class TrafficControl : public OrxonoxClass{
+class TrafficControl : public ClientConnectionListener {
   private:
 
@@ -122,4 +123,5 @@
     unsigned int currentClientID;
     unsigned int targetSize;
+    bool         bActive_;
     /**
     *copiedVector is a copy of the given Vector by the GSmanager, on this list all manipulations are performed
@@ -141,5 +143,10 @@
     void evaluateList(unsigned int clientID, std::list<obj> *list);//done    
     void ack(unsigned int clientID, unsigned int gamestateID);  // this function gets called when the server receives an ack from the client
+    
+    //ClientConnectionListener functions
+    virtual void clientConnected(unsigned int clientID){};
+    virtual void clientDisconnected(unsigned int clientID);
 
+ 
   protected:
     static TrafficControl *instance_;
@@ -154,4 +161,5 @@
     *Elements of struct i are therefore: *list[i].objID
     */
+    void setConfigValues();
     static TrafficControl *getInstance();
     void processObjectList(unsigned int clientID, unsigned int gamestateID, std::list<obj>* list); //gets a pointer to the list (containing objectIDs) and sorts it
@@ -162,5 +170,6 @@
     void deleteObject(unsigned int objectID);				// this function gets called when an object has been deleted (in order to clean up lists and maps)
     
-    bool priodiffer(uint32_t clientID, obj i, obj j);
+    bool prioritySort(uint32_t clientID, obj i, obj j);
+    bool dataSort(obj i, obj j);
     void printList(std::list<obj> *list, unsigned int clientID);
     void fixCreatorDependencies(std::list<obj>::iterator it, std::list<obj> *list, unsigned int clientID);
Index: code/branches/bugger/src/network/packet/Gamestate.cc
===================================================================
--- code/branches/bugger/src/network/packet/Gamestate.cc	(revision 2532)
+++ code/branches/bugger/src/network/packet/Gamestate.cc	(revision 2533)
@@ -349,5 +349,5 @@
   Gamestate *gs = new Gamestate(gdata);
   uint8_t *newdata = gdata + sizeof(GamestateHeader);
-//   uint8_t *origdata = GAMESTATE_START(data_);
+  uint8_t *origdata = GAMESTATE_START(data_);
 
   //copy the GamestateHeader
@@ -357,5 +357,6 @@
   uint32_t objectOffset;
   unsigned int objectsize, destsize=0;
-  Synchronisable *object;
+  // TODO: Why is this variable not used?
+  //Synchronisable *object;
 
   //call TrafficControl
@@ -366,24 +367,26 @@
     if((*it).objSize==0)
       continue;
-    oldobjectheader = (synchronisableHeader*)(data_ + (*it).objDataOffset);
+    oldobjectheader = (synchronisableHeader*)origdata;
     newobjectheader = (synchronisableHeader*)newdata;
-    object = Synchronisable::getSynchronisable( (*it).objID );
-    assert(object->objectID == oldobjectheader->objectID);
+//     object = Synchronisable::getSynchronisable( (*it).objID );
+//     assert(object->objectID == oldobjectheader->objectID);
     objectsize = oldobjectheader->size;
-    *newobjectheader = *oldobjectheader;
     objectOffset=sizeof(synchronisableHeader); //skip the size and the availableData variables in the objectheader
-    if ( /*object->doSelection(HEADER->id)*/true ){
+    if ( (*it).objID == oldobjectheader->objectID ){
+      memcpy(newdata, origdata, objectsize);
       assert(newobjectheader->dataAvailable==true);
-      memcpy(newdata+objectOffset, data_ + (*it).objDataOffset + objectOffset, objectsize-objectOffset);
+      ++it;
     }else{
+      *newobjectheader = *oldobjectheader;
       newobjectheader->dataAvailable=false;
       memset(newdata+objectOffset, 0, objectsize-objectOffset);
-      assert(objectOffset==objectsize);
     }
     newdata += objectsize;
+    origdata += objectsize;
     destsize += objectsize;
 //     origdata += objectsize;
   }
   ((GamestateHeader*)gdata)->datasize = destsize;
+  assert(destsize==HEADER->datasize);
   assert(destsize!=0);
   return gs;
Index: code/branches/bugger/src/network/synchronisable/Synchronisable.cc
===================================================================
--- code/branches/bugger/src/network/synchronisable/Synchronisable.cc	(revision 2532)
+++ code/branches/bugger/src/network/synchronisable/Synchronisable.cc	(revision 2533)
@@ -66,5 +66,4 @@
     RegisterRootObject(Synchronisable);
     static uint32_t idCounter=0;
-    objectFrequency_=1;
     objectMode_=0x1; // by default do not send data to server
     if ( !Host::running() || ( Host::running() && Host::isServer() ) )
@@ -78,16 +77,20 @@
     classID = static_cast<uint32_t>(-1);
 
-
-//#ifndef NDEBUG
-//    ObjectList<Synchronisable>::iterator it;
-//    for(it = ObjectList<Synchronisable>::begin(); it!=ObjectList<Synchronisable>::end(); ++it){
-//        if(!(*it==this || (it->objectID==OBJECTID_UNKNOWN && it->objectMode_==0x0)))
-//        {
-//            COUT(1) << "Assertion failed: *it==this || (it->objectID==OBJECTID_UNKNOWN && it->objectMode_==0x0)" << std::endl;
-//            COUT(1) << "Possible reason for this error: Client created a synchronized object without the Server's approval." << std::endl;
-//            abort();
-//        }
-//    }
-//#endif
+    // set standard priority
+    this->setPriority( priority::normal );
+
+    
+    // get creator id
+#ifndef NDEBUG
+    ObjectList<Synchronisable>::iterator it;
+    for(it = ObjectList<Synchronisable>::begin(); it!=ObjectList<Synchronisable>::end(); ++it){
+      if( it->getObjectID()==this->objectID )
+        if(!(*it==this || (it->objectID==OBJECTID_UNKNOWN && it->objectMode_==0x0))){
+          COUT(1) << "Assertion failed: *it==this || (it->objectID==OBJECTID_UNKNOWN && it->objectMode_==0x0)" << std::endl;
+          COUT(1) << "Possible reason for this error: Client created a synchronized object without the Server's approval." << std::endl;
+          abort();
+        }
+    }
+#endif
 
     this->creatorID = OBJECTID_UNKNOWN;
@@ -177,4 +180,5 @@
       {
         mem += header->size; //.TODO: this suckz.... remove size from header
+        assert(0);
         return 0;
       }
@@ -360,4 +364,5 @@
     //assert( (mode ^ objectMode_) != 0);
     if(syncList.empty()){
+      assert(0);
       COUT(4) << "Synchronisable::updateData syncList is empty" << std::endl;
       return false;
Index: code/branches/bugger/src/network/synchronisable/Synchronisable.h
===================================================================
--- code/branches/bugger/src/network/synchronisable/Synchronisable.h	(revision 2532)
+++ code/branches/bugger/src/network/synchronisable/Synchronisable.h	(revision 2533)
@@ -61,4 +61,14 @@
     };
   }
+  
+  namespace priority{
+    enum prio{
+      very_high   = -100,
+      high        = -15,
+      normal      = 0,
+      low         = 15,
+      very_low    = 100
+    };
+  }
 
   struct _NetworkExport synchronisableHeader{
@@ -101,5 +111,5 @@
     template <class T> void unregisterVariable(T& var);
     void setObjectMode(uint8_t mode);
-    void setObjectPriority(unsigned int freq){ objectFrequency_ = freq; }
+    void setPriority(unsigned int freq){ objectFrequency_ = freq; }
 
 
Index: code/branches/bugger/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- code/branches/bugger/src/orxonox/OrxonoxPrereqs.h	(revision 2532)
+++ code/branches/bugger/src/orxonox/OrxonoxPrereqs.h	(revision 2533)
@@ -103,4 +103,5 @@
     class QuestHint;
     class QuestItem;
+    class QuestListener;
     class QuestManager;
     class Rewardable;
@@ -186,4 +187,7 @@
     class HUDHealthBar;
     class InGameConsole;
+    class Notification;
+    class NotificationManager;
+    class NotificationQueue;
     class OrxonoxOverlay;
     class OverlayGroup;
Index: code/branches/bugger/src/orxonox/gamestates/GSDedicated.cc
===================================================================
--- code/branches/bugger/src/orxonox/gamestates/GSDedicated.cc	(revision 2532)
+++ code/branches/bugger/src/orxonox/gamestates/GSDedicated.cc	(revision 2533)
@@ -38,4 +38,5 @@
 #include "network/Server.h"
 #include "objects/Tickable.h"
+#include "util/Sleep.h"
 
 const unsigned int  DEFAULT_DEDICATED_SERVER_TICKRATE = 25;
Index: code/branches/bugger/src/orxonox/objects/quest/AddQuest.cc
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/AddQuest.cc	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/AddQuest.cc	(revision 2533)
@@ -28,7 +28,6 @@
 
 /**
-    @file AddQuest.cc
-    @brief
-    Implementation of the AddQuest class.
+    @file
+    @brief Implementation of the AddQuest class.
 */
 
@@ -45,6 +44,6 @@
 #include "Quest.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(AddQuest);
 
@@ -109,5 +108,5 @@
         }
 
-        COUT(3) << "Quest {" << this->getQuestId() << "} successfully added to player." << std::endl;
+        COUT(3) << "Quest {" << this->getQuestId() << "} successfully added to player: " << player << " ." << std::endl;
         return true;
     }
Index: code/branches/bugger/src/orxonox/objects/quest/AddQuest.h
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/AddQuest.h	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/AddQuest.h	(revision 2533)
@@ -28,7 +28,6 @@
 
 /**
-    @file AddQuest.h
-    @brief
-    Definition of the AddQuest class.
+    @file
+    @brief Definition of the AddQuest class.
 */
 
@@ -43,6 +42,6 @@
 #include "ChangeQuestStatus.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
@@ -58,10 +57,10 @@
     {
         public:
-            AddQuest(BaseObject* creator);
-            virtual ~AddQuest();
-
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a AddQuest object through XML.
-
-            virtual bool invoke(PlayerInfo* player); //!< Invokes the QuestEffect.
+        AddQuest(BaseObject* creator);
+        virtual ~AddQuest();
+    
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a AddQuest object through XML.
+    
+        virtual bool invoke(PlayerInfo* player); //!< Invokes the QuestEffect.
 
     };
Index: code/branches/bugger/src/orxonox/objects/quest/AddQuestHint.cc
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/AddQuestHint.cc	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/AddQuestHint.cc	(revision 2533)
@@ -28,7 +28,6 @@
 
 /**
-    @file AddQuestHint.cc
-    @brief
-    Implementation of the AddQuestHint class.
+    @file
+    @brief Implementation of the AddQuestHint class.
 */
 
@@ -44,6 +43,6 @@
 #include "QuestHint.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(AddQuestHint);
 
@@ -130,5 +129,5 @@
         }
 
-        COUT(3) << "QuestHint {" << this->getHintId() << "} successfully added to player." << std::endl;
+        COUT(3) << "QuestHint {" << this->getHintId() << "} successfully added to player: " << player << " ." << std::endl;
         return true;
 
Index: code/branches/bugger/src/orxonox/objects/quest/AddQuestHint.h
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/AddQuestHint.h	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/AddQuestHint.h	(revision 2533)
@@ -28,7 +28,6 @@
 
 /**
-    @file AddQuestHint.h
-    @brief
-    Definition of the AddQuestHint class.
+    @file
+    @brief Definition of the AddQuestHint class.
 */
 
@@ -42,6 +41,6 @@
 #include "QuestEffect.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
@@ -73,4 +72,5 @@
             inline const std::string & getHintId(void) const
                 { return this->hintId_; }
+            
             bool setHintId(const std::string & id); //!< Sets the id of the QuestHint.
 
Index: code/branches/bugger/src/orxonox/objects/quest/AddReward.cc
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/AddReward.cc	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/AddReward.cc	(revision 2533)
@@ -28,7 +28,6 @@
 
 /**
-    @file AddReward.cc
-    @brief
-    Implementation of the AddReward class.
+    @file
+    @brief Implementation of the AddReward class.
 */
 
@@ -41,6 +40,6 @@
 #include "Rewardable.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(AddReward);
 
@@ -106,4 +105,6 @@
     bool AddReward::invoke(PlayerInfo* player)
     {
+        COUT(3) << "AddReward on player: " << player << " ." << std::endl;
+        
         bool check = true;
         for ( std::list<Rewardable*>::iterator reward = this->rewards_.begin(); reward != this->rewards_.end(); ++reward )
@@ -111,4 +112,6 @@
             check = check && (*reward)->reward(player);
         }
+        
+        COUT(3) << "Rewardable successfully added to player." << player << " ." << std::endl;
 
         return check;
Index: code/branches/bugger/src/orxonox/objects/quest/AddReward.h
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/AddReward.h	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/AddReward.h	(revision 2533)
@@ -28,7 +28,6 @@
 
 /**
-    @file AddReward.h
-    @brief
-    Definition of the AddReward class.
+    @file
+    @brief Definition of the AddReward class.
 */
 
@@ -43,6 +42,6 @@
 #include "QuestEffect.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
@@ -78,4 +77,5 @@
             inline void addRewardable(Rewardable* reward)
                 { this->rewards_.push_back(reward); }
+        
             const Rewardable* getRewardables(unsigned int index) const; //!< Returns the Rewardable object at the given index.
 
Index: code/branches/bugger/src/orxonox/objects/quest/CMakeLists.txt
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/CMakeLists.txt	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/CMakeLists.txt	(revision 2533)
@@ -14,4 +14,5 @@
   QuestHint.cc
   QuestItem.cc
+  QuestListener.cc
   QuestManager.cc
   Rewardable.cc
Index: code/branches/bugger/src/orxonox/objects/quest/ChangeQuestStatus.cc
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/ChangeQuestStatus.cc	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/ChangeQuestStatus.cc	(revision 2533)
@@ -28,7 +28,6 @@
 
 /**
-    @file ChangeQuestStatus.cc
-    @brief
-    Implementation of the ChangeQuestStatus class.
+    @file
+    @brief Implementation of the ChangeQuestStatus class.
 */
 
@@ -40,6 +39,6 @@
 #include "QuestItem.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/bugger/src/orxonox/objects/quest/ChangeQuestStatus.h
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/ChangeQuestStatus.h	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/ChangeQuestStatus.h	(revision 2533)
@@ -28,7 +28,6 @@
 
 /**
-    @file ChangeQuestStatus.h
-    @brief
-    Definition of the ChangeQuestStatus class.
+    @file
+    @brief Definition of the ChangeQuestStatus class.
 */
 
@@ -43,6 +42,6 @@
 #include "QuestEffect.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
@@ -63,6 +62,6 @@
         protected:
             /**
-                @brief Returns the id of the Quest.
-                @return Returns the id of the Quest.
+            @brief Returns the id of the Quest.
+            @return Returns the id of the Quest.
             */
             inline const std::string & getQuestId(void) const
Index: code/branches/bugger/src/orxonox/objects/quest/CompleteQuest.cc
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/CompleteQuest.cc	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/CompleteQuest.cc	(revision 2533)
@@ -28,7 +28,6 @@
  
 /**
-    @file CompleteQuest.cc
-    @brief
-    Implementation of the CompleteQuest class.
+    @file
+    @brief Implementation of the CompleteQuest class.
 */
 
@@ -43,6 +42,6 @@
 #include "Quest.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(CompleteQuest);
 
Index: code/branches/bugger/src/orxonox/objects/quest/CompleteQuest.h
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/CompleteQuest.h	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/CompleteQuest.h	(revision 2533)
@@ -28,7 +28,6 @@
 
 /**
-    @file CompleteQuest.h
-    @brief
-    Definition of the CompleteQuest class.
+    @file
+    @brief Definition of the CompleteQuest class.
 */
 
@@ -43,6 +42,6 @@
 #include "ChangeQuestStatus.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     /**
     @brief
Index: code/branches/bugger/src/orxonox/objects/quest/FailQuest.cc
===================================================================
--- code/branches/bugger/src/orxonox/objects/quest/FailQuest.cc	(revision 2532)
+++ code/branches/bugger/src/orxonox/objects/quest/FailQuest.cc	(revision 2533)
@@ -28,7 +28,6 @@
  
 /**
-    @file FailQuest.cc
-    @brief
-    Implementation of the FailQuest class.
+    @file
+    @brief Implementation of the FailQuest class.
 */
 
@@ -43,6 +42,6 @@
 #include "Quest.h"
 
-namespace orxonox {
-
+namespace orxonox
+{
     CreateFactory(FailQuest);
 
